searchNodes=[{"type":"task","title":"Mix.Tasks.Webp","doc":"Invokes webp with the given args. Usage: mix webp TASK_OPTIONS PROFILE Example: mix webp default Options --runtime-config - load the runtime configuration before executing command Note flags to control this Mix task must be given before the profile: mix webp -- runtime - config default","ref":"Mix.Tasks.Webp.html"},{"type":"task","title":"Mix.Tasks.Webp.Clean","doc":"Cleand webp at path. Usage: mix webp . delete &quot;/path&quot;","ref":"Mix.Tasks.Webp.Clean.html"},{"type":"module","title":"Webp","doc":"Webp is a installer and runner for [Webp]. Profiles You can define multiple configuration profiles. By default, there is a profile called :default which you can configure its args, current directory and environment: config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] Webp configuration There are two global configurations for the webp application: :path - the path to the webp executable. Once you find the location of the executable, you can store it in a MIX_WEBP_PATH environment variable, which you can then read in your configuration file: config :webp , path : System . get_env ( &quot;MIX_WEBP_PATH&quot; )","ref":"Webp.html"},{"type":"function","title":"Webp.bin_path/0","doc":"Returns the path to the executable. The executable may not be available if it was not yet installed.","ref":"Webp.html#bin_path/0"},{"type":"function","title":"Webp.config_for!/1","doc":"Returns the configuration for the given profile. Returns nil if the profile does not exist.","ref":"Webp.html#config_for!/1"},{"type":"function","title":"Webp.convert/2","doc":"Convert Source to Destination args .","ref":"Webp.html#convert/2"},{"type":"function","title":"Webp.install_and_run/2","doc":"Convert Source to Destination if cwebp exists.","ref":"Webp.html#install_and_run/2"},{"type":"function","title":"Webp.run/2","doc":"Runs the given command with args . The given args will be appended to the configured args. The task output will be streamed directly to stdio. It returns the status of the underlying call.","ref":"Webp.html#run/2"},{"type":"module","title":"Webp.Compressor","doc":"","ref":"Webp.Compressor.html"},{"type":"function","title":"Webp.Compressor.compress_file/2","doc":"Callback implementation for Phoenix.Digester.Compressor.compress_file/2 .","ref":"Webp.Compressor.html#compress_file/2"},{"type":"function","title":"Webp.Compressor.file_extensions/0","doc":"Callback implementation for Phoenix.Digester.Compressor.file_extensions/0 .","ref":"Webp.Compressor.html#file_extensions/0"},{"type":"extras","title":"ExWebp","doc":"Mix tasks for installing and invoking webp .","ref":"readme.html"},{"type":"extras","title":"ExWebp - Installation","doc":"If you are going to build assets in production, then you add webp as a dependency on all environments but only start it in dev: def deps do [ { :webp , &quot;~&gt; 0.1&quot; , runtime : Mix . env ( ) == :dev } ] end However, if your assets are precompiled during development, then it only needs to be a dev dependency: def deps do [ { :webp , &quot;&gt;= 0.0.0&quot; , only : :dev } ] end","ref":"readme.html#installation"},{"type":"extras","title":"ExWebp - Usage: 3 ways to use: static_compressors, mix task or library -- compressor and mix task usage detailed below","doc":"Static Compressor for phoenix Note that installation requires that Phoenix watchers can accept MFArgs tuples – so you must have Phoenix &gt; v1.5.9. config :phoenix , static_compressors : [ Webp.Compressor ] mix task","ref":"readme.html#usage-3-ways-to-use-static_compressors-mix-task-or-library-compressor-and-mix-task-usage-detailed-below"},{"type":"extras","title":"ExWebp - Profiles","doc":"The first argument to webp is the execution profile. You can define multiple execution profiles with the current directory, the OS environment, and default arguments to the webp task: config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] When mix webp default is invoked, the task arguments will be appended to the ones configured above.","ref":"readme.html#profiles"},{"type":"extras","title":"ExWebp - Adding to Phoenix w/o static compressor","doc":"First add it as a dependency in your mix.exs : def deps do [ { :phoenix , &quot;~&gt; 1.6.0&quot; } , { :webp , &quot;&gt;= 0.0.0&quot; , runtime : Mix . env ( ) == :dev } ] end Now let's configure webp to use assets/images/ as the input file and compile CSS to the output location priv/static/assets/images/ : config :webp , default : [ location : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) , destination : Path . expand ( &quot;../priv/static/images/&quot; , __DIR__ ) ] Note: if you are using esbuild (the default from Phoenix v1.6), make sure you remove the import &quot;../css/app.css&quot; line at the top of assets/js/app.js so esbuild stops generating css files. Note: make sure the &quot;assets&quot; directory from priv/static is listed in the :only option for Plug.Static in your endpoint file at, for instance lib/my_app_web/endpoint.ex . For development, we want to enable watch mode. So find the watchers configuration in your config/dev.exs and add: webp : { Webp , :run , [ :default , ~w(--watch) ] } Note we are embedding source maps with absolute URLs and enabling the file system watcher. Finally, back in your mix.exs , make sure you have an assets.deploy alias for deployments [ &quot;assets.deploy&quot; : [ &quot;esbuild default --minify&quot; , &quot;webp default&quot; , &quot;phx.digest&quot; ] ]","ref":"readme.html#adding-to-phoenix-w-o-static-compressor"},{"type":"extras","title":"ExWebp - css webp support","doc":"you will need to create webp styles in css and toggle then with some js, i load modernizer with webp support in the layout below is an example css .no-webp .img-class { background-image: url(&quot;../images/img.png&quot;); background-repeat: no-repeat; left: 100px; position: absolute; height: 411px; width: 745px; } .webp .img-class { background-image: url(&quot;../images/img.webp&quot;); background-repeat: no-repeat; left: 100px; position: absolute; height: 411px; width: 745px; } and the following to the layout &lt;html class=&quot;no-js&quot; lang=&quot;en&quot;&gt; &lt;script type=&quot;text/javascript&quot;&gt; document.documentElement.classList.remove(&quot;no-js&quot;); &lt;/script&gt; &lt;script type=&quot;text/javascript&quot; src=&quot;&lt;%= Routes.static_path(@conn, &quot;/js/modernizr_webp.js&quot;) %&gt;&quot;&gt;&lt;/script&gt; &lt;/html&gt;","ref":"readme.html#css-webp-support"},{"type":"extras","title":"ExWebp - Cleanup of old assets","doc":"you can cleanup old webp assets by invoking mix webp . clean","ref":"readme.html#cleanup-of-old-assets"},{"type":"extras","title":"ExWebp - Acknowledgements","doc":"This package is based on the excellent esbuild by Wojtek Mach and José Valim.","ref":"readme.html#acknowledgements"},{"type":"extras","title":"ExWebp - License","doc":"Copyright (c) 2022 mithereal. webp source code is licensed under the MIT License .","ref":"readme.html#license"}]